"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => VitePluginDepsCache
});
module.exports = __toCommonJS(src_exports);
var import_node_fs = require("fs");
var import_fs_extra = __toESM(require("fs-extra"), 1);
var import_chokidar = __toESM(require("chokidar"), 1);
var cacheDir = "./node_modules/.vite";
var metadataPath = `${cacheDir}/deps/_metadata.json`;
function VitePluginDepsCache({ delay = 2e3, field = "vite-deps-cache" } = {}) {
  let includedCache;
  let pkgJson;
  let server;
  async function handleDeps() {
    if (!(0, import_node_fs.existsSync)(metadataPath))
      return;
    const metadataJson = await import_fs_extra.default.readJSON(metadataPath, "utf-8");
    pkgJson[field] = [...pkgJson[field], ...Object.keys(metadataJson.optimized).filter((dep) => !includedCache.includes(dep))];
    setTimeout(() => {
      if (server)
        server.watcher.unwatch("./package.json");
      import_fs_extra.default.writeJSON("./package.json", pkgJson, { spaces: 2 });
      if (server)
        server.watcher.add("./package.json");
    }, delay);
  }
  return {
    name: "vite-plugin-deps-cache",
    apply: "serve",
    async config(config) {
      var _a, _b, _c;
      pkgJson = await import_fs_extra.default.readJSON("./package.json", "utf-8");
      config.optimizeDeps = {
        ...config.optimizeDeps,
        include: [
          ...(_b = (_a = config.optimizeDeps) == null ? void 0 : _a.include) != null ? _b : [],
          ...(_c = pkgJson[field]) != null ? _c : pkgJson[field] = []
        ]
      };
    },
    configResolved(config) {
      var _a;
      includedCache = (_a = config.optimizeDeps.include) != null ? _a : [];
      const watcher = import_chokidar.default.watch(cacheDir, {
        cwd: config.root
      });
      const timer = setInterval(() => {
        if ((0, import_node_fs.existsSync)(cacheDir)) {
          watcher.on("change", (path) => {
            if (path.endsWith("_metadata.json"))
              handleDeps();
          });
          clearInterval(timer);
          handleDeps();
        }
      }, 1e3);
    },
    configureServer(_server) {
      server = _server;
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
